/*
 * This class defines a strongly connected component as a collection of nodes.
 * Exactly one of these nodes is marked as a root.
 * 
 * Aditya Mathur
 * Original: August 11, 2011
 * 
 */

import java.util.*;
public class Scc{
    
    ArrayList<Node> nodeSet;
    Node initialRoot; // Root of this SCC when first created.
    Node currentRoot; // Current root after applying LeTraon et al.'s algorithm.
    int index; // Index of this SCC.
    
    public Scc(ArrayList<Node> nodes){
        nodeSet=nodes;
    }
    
    public Scc(ArrayList<Node> nodes, Node root, int index){
        nodeSet=nodes;
        this.initialRoot=root;
        currentRoot=root;
        this.index=index;
    }
    
    public ArrayList<Node> getScc(){
        return nodeSet;
    }
    
    public void setInitialRoot(Node n){
        initialRoot=n;
        currentRoot=n;
        n.markRoot();
    }
    
    public Node getInitialRoot(){
        return initialRoot;
    }
    
      
    public void setCurrentRoot(Node n){
        currentRoot=n;
        n.markRoot();
    }
    
     public Node getCurrentRoot(){
        return currentRoot;
    }
    
    public void setIndex(int i){
        index=i;
    }
    
    public int getIndex(){
        return index;
    }
  
}// End of AnScc class